package com.example.pkejelib;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import android.R.array;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Parcelable;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.TextView;
import android.widget.Toast;
import android.nfc.NfcAdapter;
import android.nfc.Tag;
import android.nfc.tech.IsoDep;
import android.nfc.tech.NfcA;

public class MainActivity extends Activity {

	public static final String TAG = "PKEjELibApp";
	
	private TextView mTextView;
	private NfcAdapter mNfcAdapter;
	
	private byte[] libId = { (byte)0x50,(byte)0x46,(byte)0x42,(byte)0x4E };//Domylne id dla PFBN
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		mNfcAdapter = NfcAdapter.getDefaultAdapter(this);
		
		if(mNfcAdapter != null && mNfcAdapter.isEnabled()) {
			Toast.makeText(this, "NFC jest wczone.", Toast.LENGTH_LONG).show();			
		} else {
			Toast.makeText(this, "NFC nie jest wczone.", Toast.LENGTH_LONG).show();
			finish();
		}	
	}
	
	@Override
	protected void onNewIntent(Intent intent) {	
		
		super.onNewIntent(intent);
		
		if(intent.hasExtra(NfcAdapter.EXTRA_TAG)){
			Toast.makeText(this, "Nadesza intencja NFC!", Toast.LENGTH_LONG).show();
			try{
			//select AID
			byte[] APDUCommand = { 
		            (byte) 0x00, // CLA Class           
		            (byte) 0xA4, // INS Instruction     
		            (byte) 0x04, // P1  Parameter 1
		            (byte) 0x00, // P2  Parameter 2
		            (byte) 0x07, // Length
		            (byte) 0xD6,(byte) 0x16,(byte) 0x00,(byte) 0x00,(byte) 0x40,(byte) 0x01,(byte) 0x01 // AID
		        };
				// select cm
				/*byte[] APDUCommand = { 
			            (byte) 0x00, // CLA Class           
			            (byte) 0xA4, // INS Instruction     
			            (byte) 0x04, // P1  Parameter 1
			            (byte) 0x00, // P2  Parameter 2
			            (byte) 0x08, // Length
			            (byte) 0xA0,(byte) 0x00,(byte) 0x00,(byte) 0x00,(byte) 0x03,(byte) 0x00,(byte) 0x00,(byte) 0x00 // AID
			        };*/
		    
		    Tag tag = intent.getParcelableExtra(NfcAdapter.EXTRA_TAG);
		    //NfcA nfc = NfcA.get(tag);  
		    IsoDep iso = IsoDep.get(tag);
		    //byte[] ats = iso.getHistoricalBytes();
		    iso.connect();
		    iso.setTimeout(1000);
		    
		    
		    byte[] result = iso.transceive(APDUCommand);
		    //
		    	// get entry value "PFBN"
		    	byte[] APDUCommand2 = { 
			            (byte) 0xC0, // CLA Class           
			            (byte) 0x33, // INS Instruction     
			            (byte) 0x02, // P1  Parameter 1
			            (byte) 0x00, // P2  Parameter 2
			            (byte) 0x06, (byte) 0x51, (byte) 0x04, // Length(Lc cao) +  Tag + Length(tylko id biblioteki)
			            (byte) 0x50,(byte)0x46,(byte)0x42,(byte)0x4E,
			            (byte) 0x00 // Le
			        };
		    	result = iso.transceive(APDUCommand2);
		    	
		    // Initialize update
		    byte[] sec_res = iso.transceive(new byte[]{
		    	(byte) 0x80, // CLA Class           
	            (byte) 0x50, // INS Instruction     
	            (byte) 0x00, // P1  Parameter 1
	            (byte) 0x00, // P2  Parameter 2
	            (byte) 0x08, // Lc 
	            (byte) 0x06, (byte) 0x50, (byte) 0x04, (byte) 0x50,(byte)0x46,(byte)0x42,(byte)0x4E,(byte)0x4E,// Challange (losowe bajty transmisji)         
	            (byte) 0x00 // Le
		    });
		    
		   /* byte[] keyDivDat = new byte[10];
		    byte[] crdChallange = new byte[8];
		    byte[] crdCrypto = new byte[8];
		   
		    for(int i =0; i< 10;i++){
				   keyDivDat[i] = (byte)sec_res[i];
			   }
		    for(int i =12; i< 20;i++){
				   keyDivDat[i] = (byte)sec_res[i];
			   }
		    for(int i =20; i< 28;i++){
				   keyDivDat[i] = (byte)sec_res[i];
			   }
		    */
		  /*  List<Byte> ex_auth = new ArrayList<Byte>();
		    ex_auth.add((byte) 0x84);
		    ex_auth.add((byte) 0x82);
		    ex_auth.add((byte) 0x01);
		    ex_auth.add((byte) 0x00);
		    ex_auth.add((byte) 0x10);
		    
		    List<Byte> mac = Arrays.asList((byte) 0x40,(byte) 0x41,(byte) 0x42,(byte) 0x43,(byte) 0x44,
		    		(byte) 0x45,(byte) 0x46,(byte) 0x47,(byte) 0x48,(byte) 0x49,(byte) 0x4A,
		    		(byte) 0x4B,(byte) 0x4C,(byte) 0x4D,(byte) 0x4E,(byte) 0x4F);
		  
		    // 41 42 43 44 45 46 47 48 49 4A 4B 4C 4D 4E 4F;
		    ex_auth.addAll(mac);
		    
		    byte[] toExec = new byte[ex_auth.size()];
		    
		   for(int i =0; i< ex_auth.size();i++){
			   toExec[i] = (byte)ex_auth.get(i);
		   }
		    */
		   // sec_res = iso.transceive(toExec);
		    //----
		    iso.close();
		    /*StringBuilder sb = new StringBuilder();
		    for (byte b : result) {
		        sb.append(String.format("%02X ", b));
		    }
		    String ascii = new String(result, "UTF-8");
		    AlertDialog.Builder dlgAlert  = new AlertDialog.Builder(this);
		    dlgAlert.setMessage(sb + "\n------\n" + ascii);
		    dlgAlert.setTitle("Dane");
		    dlgAlert.setPositiveButton("Ok",
		    	    new DialogInterface.OnClickListener() {
		    	        public void onClick(DialogInterface dialog, int which) {
		    	          //dismiss the dialog  
		    	        }
		    	    });
		    dlgAlert.setCancelable(true);
		    dlgAlert.create().show();*/
		    StringBuilder sb = new StringBuilder();
		    for (byte b : sec_res) {
		        sb.append(String.format("%02X ", b));
		    }
		    String ascii = new String(sec_res, "UTF-8");
		    AlertDialog.Builder dlgAlert  = new AlertDialog.Builder(this);
		    dlgAlert.setMessage(sb + "\n------\n" + ascii);
		    dlgAlert.setTitle("Dane");
		    dlgAlert.setPositiveButton("Ok",
		    	    new DialogInterface.OnClickListener() {
		    	        public void onClick(DialogInterface dialog, int which) {
		    	          //dismiss the dialog  
		    	        }
		    	    });
		    dlgAlert.setCancelable(true);
		    dlgAlert.create().show();
		    
			}
			catch(Exception e){
				Log.e(TAG, e.getMessage());
				AlertDialog.Builder dlgAlert  = new AlertDialog.Builder(this);
			    dlgAlert.setMessage(e.getLocalizedMessage() +"\n" + e.getCause());
			    dlgAlert.setTitle("Bd aplikacji!");
			    dlgAlert.setPositiveButton("Ok",
			    	    new DialogInterface.OnClickListener() {
			    	        public void onClick(DialogInterface dialog, int which) {
			    	          //dismiss the dialog  
			    	        }
			    	    });
			    dlgAlert.setCancelable(true);
			    dlgAlert.create().show();
			}
		}
	}
	
	@Override
	protected void onResume() {
		
		Intent intent = new Intent(this, MainActivity.class);
		intent.addFlags(Intent.FLAG_RECEIVER_REPLACE_PENDING);
		PendingIntent pInt = PendingIntent.getActivity(this, 0, intent, 0);
		IntentFilter[] iFil = new IntentFilter[]{};
		mNfcAdapter.enableForegroundDispatch(this, pInt, iFil, null);
		super.onResume();
	}

	@Override
	protected void onPause() {
		mNfcAdapter.disableForegroundDispatch(this);
		
		super.onPause();
	}
	
	

	
	
	
	
	
	
}
